-------------------------------------------------------------+
-- Copyright  2013 Rafa Mikoajun (MIKO) | rafal@mikoweb.pl
-- license: GNU General Public License version 3 or later; see LICENSE.txt
--
-- www.mikoweb.pl
-- www.swiat-ls.pl
--
-- Gauges Mod
-- Driveway Physics Specialization
--
-- Poprawiona fizyka wasnoci jezdnych:
-- 	* pojazdy podjedzaj pod gr z wikszym trudem
------------------------------------------------------------*/

drivewayPhysic = {};

function drivewayPhysic.prerequisitesPresent(specializations)
	return true;
end;

function drivewayPhysic:load(xmlFile)
	self.driveway 				= {};
	function self.driveway.reductuion()
		local x, y, z, difference;
		x, y, z = getTranslation(self.rootNode);  -- wsprzdne pojazdu
		
		self.driveway.yLast 		= y; -- ostatnia mierzona wysoko
		self.driveway.yRatio 		= 0.0000001; -- co ile mierzy wysoko
		self.driveway.yReflection 	= y-self.driveway.yRatio; -- wysoko w punkcie zwrotnym
		self.driveway.power			= 0; -- "sia podjazdu" - warto dodatnia oznacza jazd pod gr, ujemna z gry
	end;
	
	self.driveway.reductuion();
end;

function drivewayPhysic:delete()

end;

function drivewayPhysic:mouseEvent(posX, posY, isDown, isUp, button)
end;

function drivewayPhysic:keyEvent(unicode, sym, modifier, isDown)
end;

function drivewayPhysic:update(dt)
	if self:getIsActive() then
		local x, y, z, difference;
		x, y, z = getTranslation(self.rootNode);  -- wsprzdne pojazdu
		difference = y-self.driveway.yLast;
		
		if difference>self.driveway.yRatio then -- Jazda pod gr
			self.driveway.yLast = y;
			if self.driveway.power<0 then self.driveway.yReflection = y-self.driveway.yRatio end;
		elseif difference<-self.driveway.yRatio then -- Jazda z grki
			self.driveway.yLast = y;
			if self.driveway.power>0 then self.driveway.yReflection = y+self.driveway.yRatio end;
		end;
		
		self.driveway.power = self.driveway.yLast - self.driveway.yReflection; -- obliczanie siy
		if self.driveway.power<0 then self.driveway.power = self.driveway.power*0.01
		else self.driveway.power = self.driveway.power*0.4 end; 
	end;
end;

function drivewayPhysic:updateTick(dt)
end;

function drivewayPhysic:draw()
end;